#include <avr/interrupt.h>
#include "timer.h"
/*
 * timer.c
 *
 * Created: 13.04.2023 14:13:50
 *  Author: mrnek
 */ 

static unsigned long millis = 0;

void setup_timer() {
	TCCR1B |= (1 << WGM12); //   CTC (Clear Timer on Compare Match)
	OCR1A = 250; //  ,      (   15999,   Atmega328p    16        1 )
	TIMSK1 |= (1 << OCIE1A); //        OCR1A
	sei(); //   
	TCCR1B |= (1 << CS11) | (1 << CS10); //     64 (16000000/64=250000)
}

unsigned long get_millis() {
	return millis;	
}

ISR(TIMER1_COMPA_vect) {
	++millis;
}